diff --git a/.gitignore b/.gitignore
index c928583ee..f014be9e7 100644
--- a/.gitignore
+++ b/.gitignore
@@ -5,7 +5,6 @@ src/qbittorrent
 src/qbittorrent-nox
 src/release
 src/debug
-src/base/version.h
 CMakeLists.txt.user*
 qbittorrent.pro.user*
 conf.pri
@@ -45,3 +44,9 @@ build/
 # Web UI tools
 node_modules
 package-lock.json
+
+/vcpkg_installed/
+/out/
+/screens/
+/qbit.patch
+/src/base/version.h
diff --git a/CMakeLists.txt b/CMakeLists.txt
index 86ede6b3c..ce6a8a0ec 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -1,6 +1,9 @@
-cmake_minimum_required(VERSION 3.16 FATAL_ERROR) # Policies <= CMP0097 default to NEW
+cmake_minimum_required(VERSION 3.30 FATAL_ERROR)
 
-project(qBittorrent
+# set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+
+project(
+    qBittorrent
     DESCRIPTION "The qBittorrent BitTorrent client"
     HOMEPAGE_URL "https://www.qbittorrent.org/"
     LANGUAGES CXX
@@ -14,6 +17,8 @@ set(minLibtorrent1Version 1.2.19)
 set(minLibtorrentVersion 2.0.10)
 set(minZlibVersion 1.2.11)
 
+set(deprecated-functions OFF)
+
 include(GNUInstallDirs)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)
@@ -25,7 +30,7 @@ feature_option(GUI "Build GUI application" ON)
 feature_option(WEBUI "Enable built-in HTTP server for remote control" ON)
 feature_option(STACKTRACE "Enable stacktrace support" ON)
 feature_option(TESTING "Build internal testing suite" OFF)
-feature_option(VERBOSE_CONFIGURE "Show information about PACKAGES_FOUND and PACKAGES_NOT_FOUND in the configure output (only useful for debugging the CMake build scripts)" OFF)
+feature_option(VERBOSE_CONFIGURE "Show information about PACKAGES_FOUND and PACKAGES_NOT_FOUND in the configure output (only useful for debugging the CMake build scripts)" ON)
 
 if (CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
     feature_option_dependent(DBUS
@@ -42,7 +47,7 @@ if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
 endif()
 
 if (MSVC)
-    feature_option(MSVC_RUNTIME_DYNAMIC "Use MSVC dynamic runtime library (-MD) instead of static (-MT)" ON)
+    feature_option(MSVC_RUNTIME_DYNAMIC "Use MSVC dynamic runtime library (-MD) instead of static (-MT)" OFF)
 endif()
 
 if (VERBOSE_CONFIGURE)
diff --git a/COPYING b/COPYING
deleted file mode 100644
index 9570e1fa8..000000000
--- a/COPYING
+++ /dev/null
@@ -1,17 +0,0 @@
-The qBittorrent source code is licensed under the GNU General Public License, version 2 or (at your option) any later version (GPLv2+).
-However, the binary distribution is licensed under GNU General Public License, version 3 or (at your option) any later version (GPLv3+),
-because it contains GPLv3+ assets (eg images). In both cases, the following special exception is added:
-
-In addition, as a special exception, the copyright holders give permission to
-link this program with the OpenSSL project's "OpenSSL" library (or with
-modified versions of it that use the same license as the "OpenSSL" library),
-and distribute the linked executables. You must obey the GNU General Public
-License in all respects for all of the code used other than "OpenSSL".  If you
-modify file(s), you may extend this exception to your version of the file(s),
-but you are not obligated to do so. If you do not wish to do so, delete this
-exception statement from your version.
-
-See also the AUTHORS file
-
-See COPYING.GPLv2 file for the GPLv2
-See COPYING.GPLv3 file for the GPLv3
diff --git a/COPYING.GPLv2 b/COPYING.GPLv2
deleted file mode 100644
index 9efa6fbc9..000000000
--- a/COPYING.GPLv2
+++ /dev/null
@@ -1,338 +0,0 @@
-                    GNU GENERAL PUBLIC LICENSE
-                       Version 2, June 1991
-
- Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
- <https://fsf.org/>
- Everyone is permitted to copy and distribute verbatim copies
- of this license document, but changing it is not allowed.
-
-                            Preamble
-
-  The licenses for most software are designed to take away your
-freedom to share and change it.  By contrast, the GNU General Public
-License is intended to guarantee your freedom to share and change free
-software--to make sure the software is free for all its users.  This
-General Public License applies to most of the Free Software
-Foundation's software and to any other program whose authors commit to
-using it.  (Some other Free Software Foundation software is covered by
-the GNU Lesser General Public License instead.)  You can apply it to
-your programs, too.
-
-  When we speak of free software, we are referring to freedom, not
-price.  Our General Public Licenses are designed to make sure that you
-have the freedom to distribute copies of free software (and charge for
-this service if you wish), that you receive source code or can get it
-if you want it, that you can change the software or use pieces of it
-in new free programs; and that you know you can do these things.
-
-  To protect your rights, we need to make restrictions that forbid
-anyone to deny you these rights or to ask you to surrender the rights.
-These restrictions translate to certain responsibilities for you if you
-distribute copies of the software, or if you modify it.
-
-  For example, if you distribute copies of such a program, whether
-gratis or for a fee, you must give the recipients all the rights that
-you have.  You must make sure that they, too, receive or can get the
-source code.  And you must show them these terms so they know their
-rights.
-
-  We protect your rights with two steps: (1) copyright the software, and
-(2) offer you this license which gives you legal permission to copy,
-distribute and/or modify the software.
-
-  Also, for each author's protection and ours, we want to make certain
-that everyone understands that there is no warranty for this free
-software.  If the software is modified by someone else and passed on, we
-want its recipients to know that what they have is not the original, so
-that any problems introduced by others will not reflect on the original
-authors' reputations.
-
-  Finally, any free program is threatened constantly by software
-patents.  We wish to avoid the danger that redistributors of a free
-program will individually obtain patent licenses, in effect making the
-program proprietary.  To prevent this, we have made it clear that any
-patent must be licensed for everyone's free use or not licensed at all.
-
-  The precise terms and conditions for copying, distribution and
-modification follow.
-
-                    GNU GENERAL PUBLIC LICENSE
-   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
-
-  0. This License applies to any program or other work which contains
-a notice placed by the copyright holder saying it may be distributed
-under the terms of this General Public License.  The "Program", below,
-refers to any such program or work, and a "work based on the Program"
-means either the Program or any derivative work under copyright law:
-that is to say, a work containing the Program or a portion of it,
-either verbatim or with modifications and/or translated into another
-language.  (Hereinafter, translation is included without limitation in
-the term "modification".)  Each licensee is addressed as "you".
-
-Activities other than copying, distribution and modification are not
-covered by this License; they are outside its scope.  The act of
-running the Program is not restricted, and the output from the Program
-is covered only if its contents constitute a work based on the
-Program (independent of having been made by running the Program).
-Whether that is true depends on what the Program does.
-
-  1. You may copy and distribute verbatim copies of the Program's
-source code as you receive it, in any medium, provided that you
-conspicuously and appropriately publish on each copy an appropriate
-copyright notice and disclaimer of warranty; keep intact all the
-notices that refer to this License and to the absence of any warranty;
-and give any other recipients of the Program a copy of this License
-along with the Program.
-
-You may charge a fee for the physical act of transferring a copy, and
-you may at your option offer warranty protection in exchange for a fee.
-
-  2. You may modify your copy or copies of the Program or any portion
-of it, thus forming a work based on the Program, and copy and
-distribute such modifications or work under the terms of Section 1
-above, provided that you also meet all of these conditions:
-
-    a) You must cause the modified files to carry prominent notices
-    stating that you changed the files and the date of any change.
-
-    b) You must cause any work that you distribute or publish, that in
-    whole or in part contains or is derived from the Program or any
-    part thereof, to be licensed as a whole at no charge to all third
-    parties under the terms of this License.
-
-    c) If the modified program normally reads commands interactively
-    when run, you must cause it, when started running for such
-    interactive use in the most ordinary way, to print or display an
-    announcement including an appropriate copyright notice and a
-    notice that there is no warranty (or else, saying that you provide
-    a warranty) and that users may redistribute the program under
-    these conditions, and telling the user how to view a copy of this
-    License.  (Exception: if the Program itself is interactive but
-    does not normally print such an announcement, your work based on
-    the Program is not required to print an announcement.)
-
-These requirements apply to the modified work as a whole.  If
-identifiable sections of that work are not derived from the Program,
-and can be reasonably considered independent and separate works in
-themselves, then this License, and its terms, do not apply to those
-sections when you distribute them as separate works.  But when you
-distribute the same sections as part of a whole which is a work based
-on the Program, the distribution of the whole must be on the terms of
-this License, whose permissions for other licensees extend to the
-entire whole, and thus to each and every part regardless of who wrote it.
-
-Thus, it is not the intent of this section to claim rights or contest
-your rights to work written entirely by you; rather, the intent is to
-exercise the right to control the distribution of derivative or
-collective works based on the Program.
-
-In addition, mere aggregation of another work not based on the Program
-with the Program (or with a work based on the Program) on a volume of
-a storage or distribution medium does not bring the other work under
-the scope of this License.
-
-  3. You may copy and distribute the Program (or a work based on it,
-under Section 2) in object code or executable form under the terms of
-Sections 1 and 2 above provided that you also do one of the following:
-
-    a) Accompany it with the complete corresponding machine-readable
-    source code, which must be distributed under the terms of Sections
-    1 and 2 above on a medium customarily used for software interchange; or,
-
-    b) Accompany it with a written offer, valid for at least three
-    years, to give any third party, for a charge no more than your
-    cost of physically performing source distribution, a complete
-    machine-readable copy of the corresponding source code, to be
-    distributed under the terms of Sections 1 and 2 above on a medium
-    customarily used for software interchange; or,
-
-    c) Accompany it with the information you received as to the offer
-    to distribute corresponding source code.  (This alternative is
-    allowed only for noncommercial distribution and only if you
-    received the program in object code or executable form with such
-    an offer, in accord with Subsection b above.)
-
-The source code for a work means the preferred form of the work for
-making modifications to it.  For an executable work, complete source
-code means all the source code for all modules it contains, plus any
-associated interface definition files, plus the scripts used to
-control compilation and installation of the executable.  However, as a
-special exception, the source code distributed need not include
-anything that is normally distributed (in either source or binary
-form) with the major components (compiler, kernel, and so on) of the
-operating system on which the executable runs, unless that component
-itself accompanies the executable.
-
-If distribution of executable or object code is made by offering
-access to copy from a designated place, then offering equivalent
-access to copy the source code from the same place counts as
-distribution of the source code, even though third parties are not
-compelled to copy the source along with the object code.
-
-  4. You may not copy, modify, sublicense, or distribute the Program
-except as expressly provided under this License.  Any attempt
-otherwise to copy, modify, sublicense or distribute the Program is
-void, and will automatically terminate your rights under this License.
-However, parties who have received copies, or rights, from you under
-this License will not have their licenses terminated so long as such
-parties remain in full compliance.
-
-  5. You are not required to accept this License, since you have not
-signed it.  However, nothing else grants you permission to modify or
-distribute the Program or its derivative works.  These actions are
-prohibited by law if you do not accept this License.  Therefore, by
-modifying or distributing the Program (or any work based on the
-Program), you indicate your acceptance of this License to do so, and
-all its terms and conditions for copying, distributing or modifying
-the Program or works based on it.
-
-  6. Each time you redistribute the Program (or any work based on the
-Program), the recipient automatically receives a license from the
-original licensor to copy, distribute or modify the Program subject to
-these terms and conditions.  You may not impose any further
-restrictions on the recipients' exercise of the rights granted herein.
-You are not responsible for enforcing compliance by third parties to
-this License.
-
-  7. If, as a consequence of a court judgment or allegation of patent
-infringement or for any other reason (not limited to patent issues),
-conditions are imposed on you (whether by court order, agreement or
-otherwise) that contradict the conditions of this License, they do not
-excuse you from the conditions of this License.  If you cannot
-distribute so as to satisfy simultaneously your obligations under this
-License and any other pertinent obligations, then as a consequence you
-may not distribute the Program at all.  For example, if a patent
-license would not permit royalty-free redistribution of the Program by
-all those who receive copies directly or indirectly through you, then
-the only way you could satisfy both it and this License would be to
-refrain entirely from distribution of the Program.
-
-If any portion of this section is held invalid or unenforceable under
-any particular circumstance, the balance of the section is intended to
-apply and the section as a whole is intended to apply in other
-circumstances.
-
-It is not the purpose of this section to induce you to infringe any
-patents or other property right claims or to contest validity of any
-such claims; this section has the sole purpose of protecting the
-integrity of the free software distribution system, which is
-implemented by public license practices.  Many people have made
-generous contributions to the wide range of software distributed
-through that system in reliance on consistent application of that
-system; it is up to the author/donor to decide if he or she is willing
-to distribute software through any other system and a licensee cannot
-impose that choice.
-
-This section is intended to make thoroughly clear what is believed to
-be a consequence of the rest of this License.
-
-  8. If the distribution and/or use of the Program is restricted in
-certain countries either by patents or by copyrighted interfaces, the
-original copyright holder who places the Program under this License
-may add an explicit geographical distribution limitation excluding
-those countries, so that distribution is permitted only in or among
-countries not thus excluded.  In such case, this License incorporates
-the limitation as if written in the body of this License.
-
-  9. The Free Software Foundation may publish revised and/or new versions
-of the General Public License from time to time.  Such new versions will
-be similar in spirit to the present version, but may differ in detail to
-address new problems or concerns.
-
-Each version is given a distinguishing version number.  If the Program
-specifies a version number of this License which applies to it and "any
-later version", you have the option of following the terms and conditions
-either of that version or of any later version published by the Free
-Software Foundation.  If the Program does not specify a version number of
-this License, you may choose any version ever published by the Free Software
-Foundation.
-
-  10. If you wish to incorporate parts of the Program into other free
-programs whose distribution conditions are different, write to the author
-to ask for permission.  For software which is copyrighted by the Free
-Software Foundation, write to the Free Software Foundation; we sometimes
-make exceptions for this.  Our decision will be guided by the two goals
-of preserving the free status of all derivatives of our free software and
-of promoting the sharing and reuse of software generally.
-
-                            NO WARRANTY
-
-  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
-FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
-OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
-PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
-OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
-MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
-TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
-PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
-REPAIR OR CORRECTION.
-
-  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
-WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
-REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
-INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
-OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
-TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
-YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
-PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
-POSSIBILITY OF SUCH DAMAGES.
-
-                     END OF TERMS AND CONDITIONS
-
-            How to Apply These Terms to Your New Programs
-
-  If you develop a new program, and you want it to be of the greatest
-possible use to the public, the best way to achieve this is to make it
-free software which everyone can redistribute and change under these terms.
-
-  To do so, attach the following notices to the program.  It is safest
-to attach them to the start of each source file to most effectively
-convey the exclusion of warranty; and each file should have at least
-the "copyright" line and a pointer to where the full notice is found.
-
-    <one line to give the program's name and a brief idea of what it does.>
-    Copyright (C) <year>  <name of author>
-
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 2 of the License, or
-    (at your option) any later version.
-
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
-
-    You should have received a copy of the GNU General Public License along
-    with this program; if not, see <https://www.gnu.org/licenses/>.
-
-Also add information on how to contact you by electronic and paper mail.
-
-If the program is interactive, make it output a short notice like this
-when it starts in an interactive mode:
-
-    Gnomovision version 69, Copyright (C) year name of author
-    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
-    This is free software, and you are welcome to redistribute it
-    under certain conditions; type `show c' for details.
-
-The hypothetical commands `show w' and `show c' should show the appropriate
-parts of the General Public License.  Of course, the commands you use may
-be called something other than `show w' and `show c'; they could even be
-mouse-clicks or menu items--whatever suits your program.
-
-You should also get your employer (if you work as a programmer) or your
-school, if any, to sign a "copyright disclaimer" for the program, if
-necessary.  Here is a sample; alter the names:
-
-  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
-  `Gnomovision' (which makes passes at compilers) written by James Hacker.
-
-  <signature of Moe Ghoul>, 1 April 1989
-  Moe Ghoul, President of Vice
-
-This General Public License does not permit incorporating your program into
-proprietary programs.  If your program is a subroutine library, you may
-consider it more useful to permit linking proprietary applications with the
-library.  If this is what you want to do, use the GNU Lesser General
-Public License instead of this License.
diff --git a/COPYING.GPLv3 b/COPYING.GPLv3
deleted file mode 100644
index f288702d2..000000000
--- a/COPYING.GPLv3
+++ /dev/null
@@ -1,674 +0,0 @@
-                    GNU GENERAL PUBLIC LICENSE
-                       Version 3, 29 June 2007
-
- Copyright (C) 2007 Free Software Foundation, Inc. <https://fsf.org/>
- Everyone is permitted to copy and distribute verbatim copies
- of this license document, but changing it is not allowed.
-
-                            Preamble
-
-  The GNU General Public License is a free, copyleft license for
-software and other kinds of works.
-
-  The licenses for most software and other practical works are designed
-to take away your freedom to share and change the works.  By contrast,
-the GNU General Public License is intended to guarantee your freedom to
-share and change all versions of a program--to make sure it remains free
-software for all its users.  We, the Free Software Foundation, use the
-GNU General Public License for most of our software; it applies also to
-any other work released this way by its authors.  You can apply it to
-your programs, too.
-
-  When we speak of free software, we are referring to freedom, not
-price.  Our General Public Licenses are designed to make sure that you
-have the freedom to distribute copies of free software (and charge for
-them if you wish), that you receive source code or can get it if you
-want it, that you can change the software or use pieces of it in new
-free programs, and that you know you can do these things.
-
-  To protect your rights, we need to prevent others from denying you
-these rights or asking you to surrender the rights.  Therefore, you have
-certain responsibilities if you distribute copies of the software, or if
-you modify it: responsibilities to respect the freedom of others.
-
-  For example, if you distribute copies of such a program, whether
-gratis or for a fee, you must pass on to the recipients the same
-freedoms that you received.  You must make sure that they, too, receive
-or can get the source code.  And you must show them these terms so they
-know their rights.
-
-  Developers that use the GNU GPL protect your rights with two steps:
-(1) assert copyright on the software, and (2) offer you this License
-giving you legal permission to copy, distribute and/or modify it.
-
-  For the developers' and authors' protection, the GPL clearly explains
-that there is no warranty for this free software.  For both users' and
-authors' sake, the GPL requires that modified versions be marked as
-changed, so that their problems will not be attributed erroneously to
-authors of previous versions.
-
-  Some devices are designed to deny users access to install or run
-modified versions of the software inside them, although the manufacturer
-can do so.  This is fundamentally incompatible with the aim of
-protecting users' freedom to change the software.  The systematic
-pattern of such abuse occurs in the area of products for individuals to
-use, which is precisely where it is most unacceptable.  Therefore, we
-have designed this version of the GPL to prohibit the practice for those
-products.  If such problems arise substantially in other domains, we
-stand ready to extend this provision to those domains in future versions
-of the GPL, as needed to protect the freedom of users.
-
-  Finally, every program is threatened constantly by software patents.
-States should not allow patents to restrict development and use of
-software on general-purpose computers, but in those that do, we wish to
-avoid the special danger that patents applied to a free program could
-make it effectively proprietary.  To prevent this, the GPL assures that
-patents cannot be used to render the program non-free.
-
-  The precise terms and conditions for copying, distribution and
-modification follow.
-
-                       TERMS AND CONDITIONS
-
-  0. Definitions.
-
-  "This License" refers to version 3 of the GNU General Public License.
-
-  "Copyright" also means copyright-like laws that apply to other kinds of
-works, such as semiconductor masks.
-
-  "The Program" refers to any copyrightable work licensed under this
-License.  Each licensee is addressed as "you".  "Licensees" and
-"recipients" may be individuals or organizations.
-
-  To "modify" a work means to copy from or adapt all or part of the work
-in a fashion requiring copyright permission, other than the making of an
-exact copy.  The resulting work is called a "modified version" of the
-earlier work or a work "based on" the earlier work.
-
-  A "covered work" means either the unmodified Program or a work based
-on the Program.
-
-  To "propagate" a work means to do anything with it that, without
-permission, would make you directly or secondarily liable for
-infringement under applicable copyright law, except executing it on a
-computer or modifying a private copy.  Propagation includes copying,
-distribution (with or without modification), making available to the
-public, and in some countries other activities as well.
-
-  To "convey" a work means any kind of propagation that enables other
-parties to make or receive copies.  Mere interaction with a user through
-a computer network, with no transfer of a copy, is not conveying.
-
-  An interactive user interface displays "Appropriate Legal Notices"
-to the extent that it includes a convenient and prominently visible
-feature that (1) displays an appropriate copyright notice, and (2)
-tells the user that there is no warranty for the work (except to the
-extent that warranties are provided), that licensees may convey the
-work under this License, and how to view a copy of this License.  If
-the interface presents a list of user commands or options, such as a
-menu, a prominent item in the list meets this criterion.
-
-  1. Source Code.
-
-  The "source code" for a work means the preferred form of the work
-for making modifications to it.  "Object code" means any non-source
-form of a work.
-
-  A "Standard Interface" means an interface that either is an official
-standard defined by a recognized standards body, or, in the case of
-interfaces specified for a particular programming language, one that
-is widely used among developers working in that language.
-
-  The "System Libraries" of an executable work include anything, other
-than the work as a whole, that (a) is included in the normal form of
-packaging a Major Component, but which is not part of that Major
-Component, and (b) serves only to enable use of the work with that
-Major Component, or to implement a Standard Interface for which an
-implementation is available to the public in source code form.  A
-"Major Component", in this context, means a major essential component
-(kernel, window system, and so on) of the specific operating system
-(if any) on which the executable work runs, or a compiler used to
-produce the work, or an object code interpreter used to run it.
-
-  The "Corresponding Source" for a work in object code form means all
-the source code needed to generate, install, and (for an executable
-work) run the object code and to modify the work, including scripts to
-control those activities.  However, it does not include the work's
-System Libraries, or general-purpose tools or generally available free
-programs which are used unmodified in performing those activities but
-which are not part of the work.  For example, Corresponding Source
-includes interface definition files associated with source files for
-the work, and the source code for shared libraries and dynamically
-linked subprograms that the work is specifically designed to require,
-such as by intimate data communication or control flow between those
-subprograms and other parts of the work.
-
-  The Corresponding Source need not include anything that users
-can regenerate automatically from other parts of the Corresponding
-Source.
-
-  The Corresponding Source for a work in source code form is that
-same work.
-
-  2. Basic Permissions.
-
-  All rights granted under this License are granted for the term of
-copyright on the Program, and are irrevocable provided the stated
-conditions are met.  This License explicitly affirms your unlimited
-permission to run the unmodified Program.  The output from running a
-covered work is covered by this License only if the output, given its
-content, constitutes a covered work.  This License acknowledges your
-rights of fair use or other equivalent, as provided by copyright law.
-
-  You may make, run and propagate covered works that you do not
-convey, without conditions so long as your license otherwise remains
-in force.  You may convey covered works to others for the sole purpose
-of having them make modifications exclusively for you, or provide you
-with facilities for running those works, provided that you comply with
-the terms of this License in conveying all material for which you do
-not control copyright.  Those thus making or running the covered works
-for you must do so exclusively on your behalf, under your direction
-and control, on terms that prohibit them from making any copies of
-your copyrighted material outside their relationship with you.
-
-  Conveying under any other circumstances is permitted solely under
-the conditions stated below.  Sublicensing is not allowed; section 10
-makes it unnecessary.
-
-  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
-
-  No covered work shall be deemed part of an effective technological
-measure under any applicable law fulfilling obligations under article
-11 of the WIPO copyright treaty adopted on 20 December 1996, or
-similar laws prohibiting or restricting circumvention of such
-measures.
-
-  When you convey a covered work, you waive any legal power to forbid
-circumvention of technological measures to the extent such circumvention
-is effected by exercising rights under this License with respect to
-the covered work, and you disclaim any intention to limit operation or
-modification of the work as a means of enforcing, against the work's
-users, your or third parties' legal rights to forbid circumvention of
-technological measures.
-
-  4. Conveying Verbatim Copies.
-
-  You may convey verbatim copies of the Program's source code as you
-receive it, in any medium, provided that you conspicuously and
-appropriately publish on each copy an appropriate copyright notice;
-keep intact all notices stating that this License and any
-non-permissive terms added in accord with section 7 apply to the code;
-keep intact all notices of the absence of any warranty; and give all
-recipients a copy of this License along with the Program.
-
-  You may charge any price or no price for each copy that you convey,
-and you may offer support or warranty protection for a fee.
-
-  5. Conveying Modified Source Versions.
-
-  You may convey a work based on the Program, or the modifications to
-produce it from the Program, in the form of source code under the
-terms of section 4, provided that you also meet all of these conditions:
-
-    a) The work must carry prominent notices stating that you modified
-    it, and giving a relevant date.
-
-    b) The work must carry prominent notices stating that it is
-    released under this License and any conditions added under section
-    7.  This requirement modifies the requirement in section 4 to
-    "keep intact all notices".
-
-    c) You must license the entire work, as a whole, under this
-    License to anyone who comes into possession of a copy.  This
-    License will therefore apply, along with any applicable section 7
-    additional terms, to the whole of the work, and all its parts,
-    regardless of how they are packaged.  This License gives no
-    permission to license the work in any other way, but it does not
-    invalidate such permission if you have separately received it.
-
-    d) If the work has interactive user interfaces, each must display
-    Appropriate Legal Notices; however, if the Program has interactive
-    interfaces that do not display Appropriate Legal Notices, your
-    work need not make them do so.
-
-  A compilation of a covered work with other separate and independent
-works, which are not by their nature extensions of the covered work,
-and which are not combined with it such as to form a larger program,
-in or on a volume of a storage or distribution medium, is called an
-"aggregate" if the compilation and its resulting copyright are not
-used to limit the access or legal rights of the compilation's users
-beyond what the individual works permit.  Inclusion of a covered work
-in an aggregate does not cause this License to apply to the other
-parts of the aggregate.
-
-  6. Conveying Non-Source Forms.
-
-  You may convey a covered work in object code form under the terms
-of sections 4 and 5, provided that you also convey the
-machine-readable Corresponding Source under the terms of this License,
-in one of these ways:
-
-    a) Convey the object code in, or embodied in, a physical product
-    (including a physical distribution medium), accompanied by the
-    Corresponding Source fixed on a durable physical medium
-    customarily used for software interchange.
-
-    b) Convey the object code in, or embodied in, a physical product
-    (including a physical distribution medium), accompanied by a
-    written offer, valid for at least three years and valid for as
-    long as you offer spare parts or customer support for that product
-    model, to give anyone who possesses the object code either (1) a
-    copy of the Corresponding Source for all the software in the
-    product that is covered by this License, on a durable physical
-    medium customarily used for software interchange, for a price no
-    more than your reasonable cost of physically performing this
-    conveying of source, or (2) access to copy the
-    Corresponding Source from a network server at no charge.
-
-    c) Convey individual copies of the object code with a copy of the
-    written offer to provide the Corresponding Source.  This
-    alternative is allowed only occasionally and noncommercially, and
-    only if you received the object code with such an offer, in accord
-    with subsection 6b.
-
-    d) Convey the object code by offering access from a designated
-    place (gratis or for a charge), and offer equivalent access to the
-    Corresponding Source in the same way through the same place at no
-    further charge.  You need not require recipients to copy the
-    Corresponding Source along with the object code.  If the place to
-    copy the object code is a network server, the Corresponding Source
-    may be on a different server (operated by you or a third party)
-    that supports equivalent copying facilities, provided you maintain
-    clear directions next to the object code saying where to find the
-    Corresponding Source.  Regardless of what server hosts the
-    Corresponding Source, you remain obligated to ensure that it is
-    available for as long as needed to satisfy these requirements.
-
-    e) Convey the object code using peer-to-peer transmission, provided
-    you inform other peers where the object code and Corresponding
-    Source of the work are being offered to the general public at no
-    charge under subsection 6d.
-
-  A separable portion of the object code, whose source code is excluded
-from the Corresponding Source as a System Library, need not be
-included in conveying the object code work.
-
-  A "User Product" is either (1) a "consumer product", which means any
-tangible personal property which is normally used for personal, family,
-or household purposes, or (2) anything designed or sold for incorporation
-into a dwelling.  In determining whether a product is a consumer product,
-doubtful cases shall be resolved in favor of coverage.  For a particular
-product received by a particular user, "normally used" refers to a
-typical or common use of that class of product, regardless of the status
-of the particular user or of the way in which the particular user
-actually uses, or expects or is expected to use, the product.  A product
-is a consumer product regardless of whether the product has substantial
-commercial, industrial or non-consumer uses, unless such uses represent
-the only significant mode of use of the product.
-
-  "Installation Information" for a User Product means any methods,
-procedures, authorization keys, or other information required to install
-and execute modified versions of a covered work in that User Product from
-a modified version of its Corresponding Source.  The information must
-suffice to ensure that the continued functioning of the modified object
-code is in no case prevented or interfered with solely because
-modification has been made.
-
-  If you convey an object code work under this section in, or with, or
-specifically for use in, a User Product, and the conveying occurs as
-part of a transaction in which the right of possession and use of the
-User Product is transferred to the recipient in perpetuity or for a
-fixed term (regardless of how the transaction is characterized), the
-Corresponding Source conveyed under this section must be accompanied
-by the Installation Information.  But this requirement does not apply
-if neither you nor any third party retains the ability to install
-modified object code on the User Product (for example, the work has
-been installed in ROM).
-
-  The requirement to provide Installation Information does not include a
-requirement to continue to provide support service, warranty, or updates
-for a work that has been modified or installed by the recipient, or for
-the User Product in which it has been modified or installed.  Access to a
-network may be denied when the modification itself materially and
-adversely affects the operation of the network or violates the rules and
-protocols for communication across the network.
-
-  Corresponding Source conveyed, and Installation Information provided,
-in accord with this section must be in a format that is publicly
-documented (and with an implementation available to the public in
-source code form), and must require no special password or key for
-unpacking, reading or copying.
-
-  7. Additional Terms.
-
-  "Additional permissions" are terms that supplement the terms of this
-License by making exceptions from one or more of its conditions.
-Additional permissions that are applicable to the entire Program shall
-be treated as though they were included in this License, to the extent
-that they are valid under applicable law.  If additional permissions
-apply only to part of the Program, that part may be used separately
-under those permissions, but the entire Program remains governed by
-this License without regard to the additional permissions.
-
-  When you convey a copy of a covered work, you may at your option
-remove any additional permissions from that copy, or from any part of
-it.  (Additional permissions may be written to require their own
-removal in certain cases when you modify the work.)  You may place
-additional permissions on material, added by you to a covered work,
-for which you have or can give appropriate copyright permission.
-
-  Notwithstanding any other provision of this License, for material you
-add to a covered work, you may (if authorized by the copyright holders of
-that material) supplement the terms of this License with terms:
-
-    a) Disclaiming warranty or limiting liability differently from the
-    terms of sections 15 and 16 of this License; or
-
-    b) Requiring preservation of specified reasonable legal notices or
-    author attributions in that material or in the Appropriate Legal
-    Notices displayed by works containing it; or
-
-    c) Prohibiting misrepresentation of the origin of that material, or
-    requiring that modified versions of such material be marked in
-    reasonable ways as different from the original version; or
-
-    d) Limiting the use for publicity purposes of names of licensors or
-    authors of the material; or
-
-    e) Declining to grant rights under trademark law for use of some
-    trade names, trademarks, or service marks; or
-
-    f) Requiring indemnification of licensors and authors of that
-    material by anyone who conveys the material (or modified versions of
-    it) with contractual assumptions of liability to the recipient, for
-    any liability that these contractual assumptions directly impose on
-    those licensors and authors.
-
-  All other non-permissive additional terms are considered "further
-restrictions" within the meaning of section 10.  If the Program as you
-received it, or any part of it, contains a notice stating that it is
-governed by this License along with a term that is a further
-restriction, you may remove that term.  If a license document contains
-a further restriction but permits relicensing or conveying under this
-License, you may add to a covered work material governed by the terms
-of that license document, provided that the further restriction does
-not survive such relicensing or conveying.
-
-  If you add terms to a covered work in accord with this section, you
-must place, in the relevant source files, a statement of the
-additional terms that apply to those files, or a notice indicating
-where to find the applicable terms.
-
-  Additional terms, permissive or non-permissive, may be stated in the
-form of a separately written license, or stated as exceptions;
-the above requirements apply either way.
-
-  8. Termination.
-
-  You may not propagate or modify a covered work except as expressly
-provided under this License.  Any attempt otherwise to propagate or
-modify it is void, and will automatically terminate your rights under
-this License (including any patent licenses granted under the third
-paragraph of section 11).
-
-  However, if you cease all violation of this License, then your
-license from a particular copyright holder is reinstated (a)
-provisionally, unless and until the copyright holder explicitly and
-finally terminates your license, and (b) permanently, if the copyright
-holder fails to notify you of the violation by some reasonable means
-prior to 60 days after the cessation.
-
-  Moreover, your license from a particular copyright holder is
-reinstated permanently if the copyright holder notifies you of the
-violation by some reasonable means, this is the first time you have
-received notice of violation of this License (for any work) from that
-copyright holder, and you cure the violation prior to 30 days after
-your receipt of the notice.
-
-  Termination of your rights under this section does not terminate the
-licenses of parties who have received copies or rights from you under
-this License.  If your rights have been terminated and not permanently
-reinstated, you do not qualify to receive new licenses for the same
-material under section 10.
-
-  9. Acceptance Not Required for Having Copies.
-
-  You are not required to accept this License in order to receive or
-run a copy of the Program.  Ancillary propagation of a covered work
-occurring solely as a consequence of using peer-to-peer transmission
-to receive a copy likewise does not require acceptance.  However,
-nothing other than this License grants you permission to propagate or
-modify any covered work.  These actions infringe copyright if you do
-not accept this License.  Therefore, by modifying or propagating a
-covered work, you indicate your acceptance of this License to do so.
-
-  10. Automatic Licensing of Downstream Recipients.
-
-  Each time you convey a covered work, the recipient automatically
-receives a license from the original licensors, to run, modify and
-propagate that work, subject to this License.  You are not responsible
-for enforcing compliance by third parties with this License.
-
-  An "entity transaction" is a transaction transferring control of an
-organization, or substantially all assets of one, or subdividing an
-organization, or merging organizations.  If propagation of a covered
-work results from an entity transaction, each party to that
-transaction who receives a copy of the work also receives whatever
-licenses to the work the party's predecessor in interest had or could
-give under the previous paragraph, plus a right to possession of the
-Corresponding Source of the work from the predecessor in interest, if
-the predecessor has it or can get it with reasonable efforts.
-
-  You may not impose any further restrictions on the exercise of the
-rights granted or affirmed under this License.  For example, you may
-not impose a license fee, royalty, or other charge for exercise of
-rights granted under this License, and you may not initiate litigation
-(including a cross-claim or counterclaim in a lawsuit) alleging that
-any patent claim is infringed by making, using, selling, offering for
-sale, or importing the Program or any portion of it.
-
-  11. Patents.
-
-  A "contributor" is a copyright holder who authorizes use under this
-License of the Program or a work on which the Program is based.  The
-work thus licensed is called the contributor's "contributor version".
-
-  A contributor's "essential patent claims" are all patent claims
-owned or controlled by the contributor, whether already acquired or
-hereafter acquired, that would be infringed by some manner, permitted
-by this License, of making, using, or selling its contributor version,
-but do not include claims that would be infringed only as a
-consequence of further modification of the contributor version.  For
-purposes of this definition, "control" includes the right to grant
-patent sublicenses in a manner consistent with the requirements of
-this License.
-
-  Each contributor grants you a non-exclusive, worldwide, royalty-free
-patent license under the contributor's essential patent claims, to
-make, use, sell, offer for sale, import and otherwise run, modify and
-propagate the contents of its contributor version.
-
-  In the following three paragraphs, a "patent license" is any express
-agreement or commitment, however denominated, not to enforce a patent
-(such as an express permission to practice a patent or covenant not to
-sue for patent infringement).  To "grant" such a patent license to a
-party means to make such an agreement or commitment not to enforce a
-patent against the party.
-
-  If you convey a covered work, knowingly relying on a patent license,
-and the Corresponding Source of the work is not available for anyone
-to copy, free of charge and under the terms of this License, through a
-publicly available network server or other readily accessible means,
-then you must either (1) cause the Corresponding Source to be so
-available, or (2) arrange to deprive yourself of the benefit of the
-patent license for this particular work, or (3) arrange, in a manner
-consistent with the requirements of this License, to extend the patent
-license to downstream recipients.  "Knowingly relying" means you have
-actual knowledge that, but for the patent license, your conveying the
-covered work in a country, or your recipient's use of the covered work
-in a country, would infringe one or more identifiable patents in that
-country that you have reason to believe are valid.
-
-  If, pursuant to or in connection with a single transaction or
-arrangement, you convey, or propagate by procuring conveyance of, a
-covered work, and grant a patent license to some of the parties
-receiving the covered work authorizing them to use, propagate, modify
-or convey a specific copy of the covered work, then the patent license
-you grant is automatically extended to all recipients of the covered
-work and works based on it.
-
-  A patent license is "discriminatory" if it does not include within
-the scope of its coverage, prohibits the exercise of, or is
-conditioned on the non-exercise of one or more of the rights that are
-specifically granted under this License.  You may not convey a covered
-work if you are a party to an arrangement with a third party that is
-in the business of distributing software, under which you make payment
-to the third party based on the extent of your activity of conveying
-the work, and under which the third party grants, to any of the
-parties who would receive the covered work from you, a discriminatory
-patent license (a) in connection with copies of the covered work
-conveyed by you (or copies made from those copies), or (b) primarily
-for and in connection with specific products or compilations that
-contain the covered work, unless you entered into that arrangement,
-or that patent license was granted, prior to 28 March 2007.
-
-  Nothing in this License shall be construed as excluding or limiting
-any implied license or other defenses to infringement that may
-otherwise be available to you under applicable patent law.
-
-  12. No Surrender of Others' Freedom.
-
-  If conditions are imposed on you (whether by court order, agreement or
-otherwise) that contradict the conditions of this License, they do not
-excuse you from the conditions of this License.  If you cannot convey a
-covered work so as to satisfy simultaneously your obligations under this
-License and any other pertinent obligations, then as a consequence you may
-not convey it at all.  For example, if you agree to terms that obligate you
-to collect a royalty for further conveying from those to whom you convey
-the Program, the only way you could satisfy both those terms and this
-License would be to refrain entirely from conveying the Program.
-
-  13. Use with the GNU Affero General Public License.
-
-  Notwithstanding any other provision of this License, you have
-permission to link or combine any covered work with a work licensed
-under version 3 of the GNU Affero General Public License into a single
-combined work, and to convey the resulting work.  The terms of this
-License will continue to apply to the part which is the covered work,
-but the special requirements of the GNU Affero General Public License,
-section 13, concerning interaction through a network will apply to the
-combination as such.
-
-  14. Revised Versions of this License.
-
-  The Free Software Foundation may publish revised and/or new versions of
-the GNU General Public License from time to time.  Such new versions will
-be similar in spirit to the present version, but may differ in detail to
-address new problems or concerns.
-
-  Each version is given a distinguishing version number.  If the
-Program specifies that a certain numbered version of the GNU General
-Public License "or any later version" applies to it, you have the
-option of following the terms and conditions either of that numbered
-version or of any later version published by the Free Software
-Foundation.  If the Program does not specify a version number of the
-GNU General Public License, you may choose any version ever published
-by the Free Software Foundation.
-
-  If the Program specifies that a proxy can decide which future
-versions of the GNU General Public License can be used, that proxy's
-public statement of acceptance of a version permanently authorizes you
-to choose that version for the Program.
-
-  Later license versions may give you additional or different
-permissions.  However, no additional obligations are imposed on any
-author or copyright holder as a result of your choosing to follow a
-later version.
-
-  15. Disclaimer of Warranty.
-
-  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
-APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
-HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
-OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
-THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
-PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
-IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
-ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
-
-  16. Limitation of Liability.
-
-  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
-WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
-THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
-GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
-USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
-DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
-PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
-EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
-SUCH DAMAGES.
-
-  17. Interpretation of Sections 15 and 16.
-
-  If the disclaimer of warranty and limitation of liability provided
-above cannot be given local legal effect according to their terms,
-reviewing courts shall apply local law that most closely approximates
-an absolute waiver of all civil liability in connection with the
-Program, unless a warranty or assumption of liability accompanies a
-copy of the Program in return for a fee.
-
-                     END OF TERMS AND CONDITIONS
-
-            How to Apply These Terms to Your New Programs
-
-  If you develop a new program, and you want it to be of the greatest
-possible use to the public, the best way to achieve this is to make it
-free software which everyone can redistribute and change under these terms.
-
-  To do so, attach the following notices to the program.  It is safest
-to attach them to the start of each source file to most effectively
-state the exclusion of warranty; and each file should have at least
-the "copyright" line and a pointer to where the full notice is found.
-
-    <one line to give the program's name and a brief idea of what it does.>
-    Copyright (C) <year>  <name of author>
-
-    This program is free software: you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    (at your option) any later version.
-
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
-
-    You should have received a copy of the GNU General Public License
-    along with this program.  If not, see <https://www.gnu.org/licenses/>.
-
-Also add information on how to contact you by electronic and paper mail.
-
-  If the program does terminal interaction, make it output a short
-notice like this when it starts in an interactive mode:
-
-    <program>  Copyright (C) <year>  <name of author>
-    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
-    This is free software, and you are welcome to redistribute it
-    under certain conditions; type `show c' for details.
-
-The hypothetical commands `show w' and `show c' should show the appropriate
-parts of the General Public License.  Of course, your program's commands
-might be different; for a GUI interface, you would use an "about box".
-
-  You should also get your employer (if you work as a programmer) or school,
-if any, to sign a "copyright disclaimer" for the program, if necessary.
-For more information on this, and how to apply and follow the GNU GPL, see
-<https://www.gnu.org/licenses/>.
-
-  The GNU General Public License does not permit incorporating your program
-into proprietary programs.  If your program is a subroutine library, you
-may consider it more useful to permit linking proprietary applications with
-the library.  If this is what you want to do, use the GNU Lesser General
-Public License instead of this License.  But first, please read
-<https://www.gnu.org/licenses/why-not-lgpl.html>.
diff --git a/cmake/Modules/CommonConfig.cmake b/cmake/Modules/CommonConfig.cmake
index b57dc4bcf..2b0a38e0a 100644
--- a/cmake/Modules/CommonConfig.cmake
+++ b/cmake/Modules/CommonConfig.cmake
@@ -16,7 +16,7 @@ add_library(qbt_common_cfg INTERFACE)
 # See also https://cmake.org/cmake/help/latest/prop_gbl/CMAKE_CXX_KNOWN_FEATURES.html
 # for a breakdown of the features that CMake recognizes for each C++ standard
 target_compile_features(qbt_common_cfg INTERFACE
-    cxx_std_20
+    cxx_std_23
 )
 
 target_compile_definitions(qbt_common_cfg INTERFACE
@@ -27,6 +27,7 @@ target_compile_definitions(qbt_common_cfg INTERFACE
     QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
     QT_USE_QSTRINGBUILDER
     QT_STRICT_ITERATORS
+    _ALLOW_COROUTINE_ABI_MISMATCH
     $<$<NOT:$<CONFIG:Debug>>:QT_NO_DEBUG_OUTPUT>
 )
 
diff --git a/dist/windows/config.nsh b/dist/windows/config.nsh
index cd4e66afa..658262782 100644
--- a/dist/windows/config.nsh
+++ b/dist/windows/config.nsh
@@ -14,7 +14,7 @@
 ; 4.5.1.3 -> good
 ; 4.5.1.3.2 -> bad
 ; 4.5.0beta -> bad
-!define /ifndef QBT_VERSION "5.1.0"
+!define /ifndef QBT_VERSION "5.0.0"
 
 ; Option that controls the installer's window name
 ; If set, its value will be used like this:
diff --git a/src/app/application.cpp b/src/app/application.cpp
index 1d10731ed..6c0d6857e 100644
--- a/src/app/application.cpp
+++ b/src/app/application.cpp
@@ -55,6 +55,7 @@
 #include <QMessageBox>
 #include <QPixmapCache>
 #include <QProgressDialog>
+#include <QFont>
 #ifdef Q_OS_WIN
 #include <QSessionManager>
 #endif // Q_OS_WIN
@@ -253,6 +254,18 @@ Application::Application(int &argc, char **argv)
     setQuitOnLastWindowClosed(false);
     setQuitLockEnabled(false);
     QPixmapCache::setCacheLimit(PIXMAP_CACHE_SIZE);
+    
+    // patch: 界面组件样式优化，默认的 fusion style 都是圆角不好看
+    this->setStyle(u"windowsvista"_s);
+    
+    // patch: 字体显示优化
+    // https://stackoverflow.com/questions/61697971
+    QFont font = QFont(u"MyFont"_s);
+    font.setHintingPreference(QFont::PreferNoHinting);
+    this->setFont(font);
+    
+    // patch: 字体大小设置
+    this->setStyleSheet(u"QWidget { font-size: 17px; }"_s);
 #endif
 
     Logger::initInstance();
diff --git a/src/app/main.cpp b/src/app/main.cpp
index d80629f44..f5907cbd0 100644
--- a/src/app/main.cpp
+++ b/src/app/main.cpp
@@ -139,7 +139,8 @@ namespace
         QPainter painter(&splashImg);
         const auto version = QStringLiteral(QBT_VERSION);
         painter.setPen(QPen(Qt::white));
-        painter.setFont(QFont(u"Arial"_s, 22, QFont::Black));
+        // patch: 字体显示优化
+        painter.setFont(QFont(u"MyFont"_s, 22, QFont::Black));
         painter.drawText(224 - painter.fontMetrics().horizontalAdvance(version), 270, version);
         QSplashScreen *splash = new QSplashScreen(splashImg);
         splash->show();
diff --git a/src/base/bittorrent/peer_blacklist.hpp b/src/base/bittorrent/peer_blacklist.hpp
new file mode 100644
index 000000000..50208203d
--- /dev/null
+++ b/src/base/bittorrent/peer_blacklist.hpp
@@ -0,0 +1,124 @@
+#pragma once
+
+// https://github.com/c0re100/qBittorrent-Enhanced-Edition
+// 同步时的 hash: fb6e1aee75cd5638b48907c49329dcf96bd9d4e2
+
+#include <regex>
+
+#include <libtorrent/torrent_info.hpp>
+
+#include <QHostAddress>
+
+#include "base/net/geoipmanager.h"
+
+#include "peer_filter_plugin.hpp"
+#include "peer_logger.hpp"
+
+// bad peer filter
+bool is_bad_peer (const lt::peer_info& info) {
+    // XL: xunlei
+    // SD: xunlei
+    // XF: Xfplay 影音先锋
+    // QD: qqdownload
+    // BN: ?
+    // DL: ?
+    // TS: TorrentStorm
+    // DT: dt/torrent  https://bgm.tv/group/topic/394571
+    // HP: hp/torrent https://github.com/c0re100/qBittorrent-Enhanced-Edition/issues/537
+    // A2-1-: aria2/1.xx.x
+    static const std::regex id_filter("-(XL|SD|XF|QD|BN|DL|TS|DT|HP)(\\d+)-|^A2-1-.*");
+    
+    static const std::regex ua_filter(R"((\d+.\d+.\d+.\d+|cacao_torrent|^aria2.*))");
+    
+    static const std::regex consume_filter(R"(((dt|hp|xm)/torrent|Taipei-torrent( dev)?|gopeed( dev)?|go.torrent.*))", std::regex_constants::icase);
+    
+    const std::string ip = info.ip.address().to_string();
+    
+    return
+        std::regex_match(info.pid.data(), info.pid.data() + 8, id_filter) || 
+        std::regex_match(info.client, ua_filter) ||
+        std::regex_match(info.client, consume_filter) ||
+        ip.starts_with("61.160.241.") || 
+        ip.starts_with("125.77.176.") ||
+        ip.starts_with("58.218.213.");
+}
+
+
+// Unknown Peer filter
+bool is_unknown_peer (const lt::peer_info& info) {
+    QString country = Net::GeoIPManager::instance()->lookup(QHostAddress(info.ip.data()));
+    return info.client.find("Unknown") != std::string::npos && country == QLatin1String("CN");
+}
+
+
+// Offline Downloader filter
+bool is_offline_downloader (const lt::peer_info& info) {
+    static const std::regex id_filter("-LT(1220|2070)-");
+    unsigned short port = info.ip.port();
+    QString country = Net::GeoIPManager::instance()->lookup(QHostAddress(info.ip.data()));
+    // 115: Old data, may out of date.
+    bool fake_transmission = port >= 65000 && country == QLatin1String("CN") && info.client.find("Transmission") != std::string::npos;
+    // PikPak: PikPak is renting Worldstream server and announce as LT1220/LT2070, the best way is block the ip range via ip filter(?)
+    // Xunlei: it seems Xunlei is using LT2070 too
+    bool fake_libtorrent = (country == QLatin1String("NL") || country == QLatin1String("CN")) && std::regex_match(info.pid.data(), info.pid.data() + 8, id_filter);
+    return fake_transmission || fake_libtorrent;
+}
+
+
+// BitTorrent Media Player Peer filter
+bool is_bittorrent_media_player (const lt::peer_info& info) {
+    if (info.client.find("StellarPlayer") != std::string::npos || info.client.find("Elementum") != std::string::npos) {
+        return true;
+    }
+    static const std::regex player_filter("-(UW\\w{4}|SP(([0-2]\\d{3})|(3[0-5]\\d{2})))-");
+    return !!std::regex_match(info.pid.data(), info.pid.data() + 8, player_filter);
+}
+
+
+// drop connection action
+void drop_connection (lt::peer_connection_handle ph) {
+    ph.disconnect(boost::asio::error::connection_refused, lt::operation_t::bittorrent, lt::disconnect_severity_t { 0 });
+}
+
+
+template <typename F>
+auto wrap_filter (F filter, const std::string& tag) {
+    return [=] (const lt::peer_info& info, bool handshake, bool* stop_filtering) {
+        bool matched = filter(info);
+        *stop_filtering = !handshake && !matched;
+        if (matched)
+            peer_logger_singleton::instance().log_peer(info, tag);
+        return matched;
+    };
+}
+
+
+std::shared_ptr<lt::torrent_plugin> create_peer_action_plugin (
+    const lt::torrent_handle& th,
+    filter_function filter,
+    action_function action
+) {
+    // ignore private torrents
+    if (th.torrent_file() && th.torrent_file()->priv())
+        return nullptr;
+    else
+        return std::make_shared<peer_action_plugin>(std::move(filter), std::move(action));
+}
+
+
+// --- plugins factory functions
+std::shared_ptr<lt::torrent_plugin> create_drop_bad_peers_plugin (lt::torrent_handle const& th, client_data) {
+    return create_peer_action_plugin(th, wrap_filter(is_bad_peer, "bad peer"), drop_connection);
+}
+
+std::shared_ptr<lt::torrent_plugin> create_drop_unknown_peers_plugin (lt::torrent_handle const& th, client_data) {
+    return create_peer_action_plugin(th, wrap_filter(is_unknown_peer, "unknown peer"), drop_connection);
+}
+
+std::shared_ptr<lt::torrent_plugin> create_drop_offline_downloader_plugin (lt::torrent_handle const& th, client_data) {
+    return create_peer_action_plugin(th, wrap_filter(is_offline_downloader, "offline downloader"), drop_connection);
+}
+
+std::shared_ptr<lt::torrent_plugin> create_drop_bittorrent_media_player_plugin (lt::torrent_handle const& th, client_data) {
+    return create_peer_action_plugin(th, wrap_filter(is_bittorrent_media_player, "bittorrent media player"), drop_connection);
+}
diff --git a/src/base/bittorrent/peer_filter.hpp b/src/base/bittorrent/peer_filter.hpp
new file mode 100644
index 000000000..75234c331
--- /dev/null
+++ b/src/base/bittorrent/peer_filter.hpp
@@ -0,0 +1,69 @@
+#pragma once
+
+#include <algorithm>
+#include <fstream>
+#include <string>
+
+#include <QFileInfo>
+#include <QRegularExpression>
+#include <QString>
+#include <QVector>
+
+#include <libtorrent/peer_info.hpp>
+
+#include "base/logger.h"
+
+namespace {
+
+bool qregex_has_match(const QRegularExpression& re, const QString& str)
+{
+  auto m = re.match(str);
+  return m.hasMatch();
+}
+
+}
+
+class peer_filter
+{
+public:
+  explicit peer_filter(const QString& filter_file)
+  {
+    QString log_tag = QFileInfo(filter_file).fileName();
+
+    std::ifstream ifs(filter_file.toStdString());
+    std::string peer_id, client;
+    while (ifs >> peer_id >> client) {
+      QRegularExpression peer_id_re(QString::fromStdString(peer_id));
+      QRegularExpression client_re(QString::fromStdString(client));
+
+      auto msg_tmpl = u"'%1': invalid %2 matching expression '%3' detected at line %4, ignoring rule"_s;
+      int line = m_filters.size() + 1;
+
+      if (!peer_id_re.isValid())
+        LogMsg(msg_tmpl.arg(log_tag).arg(u"peer id"_s).arg(peer_id_re.pattern()).arg(line), Log::WARNING);
+
+      if (!client_re.isValid())
+        LogMsg(msg_tmpl.arg(log_tag).arg(u"client name"_s).arg(client_re.pattern()).arg(line), Log::WARNING);
+
+      if (peer_id_re.isValid() && client_re.isValid())
+        m_filters.append({peer_id_re, client_re});
+    }
+  }
+
+  bool match_peer(const lt::peer_info& info, bool skip_name) const
+  {
+    QString peer_id = QString::fromLatin1(info.pid.data(), 8);
+    QString client = QString::fromStdString(info.client);
+    return std::any_of(m_filters.begin(), m_filters.end(),
+                       [&](const auto& filter) {
+                           return qregex_has_match(filter[0], peer_id) &&
+                               (skip_name || qregex_has_match(filter[1], client));
+                       });
+  }
+
+  bool is_empty() const { return m_filters.isEmpty(); }
+  int rules_count() const { return m_filters.size(); }
+
+private:
+  QVector<QVector<QRegularExpression>> m_filters;
+};
diff --git a/src/base/bittorrent/peer_filter_plugin.hpp b/src/base/bittorrent/peer_filter_plugin.hpp
new file mode 100644
index 000000000..ee4adfc13
--- /dev/null
+++ b/src/base/bittorrent/peer_filter_plugin.hpp
@@ -0,0 +1,123 @@
+#pragma once
+
+#include <libtorrent/extensions.hpp>
+#include <libtorrent/peer_connection_handle.hpp>
+
+#if (LIBTORRENT_VERSION_NUM >= 20000)
+using client_data = lt::client_data_t;
+#else
+using client_data = void*;
+#endif
+
+using filter_function = std::function<bool(const lt::peer_info&, bool, bool*)>;
+using action_function = std::function<void(lt::peer_connection_handle)>;
+
+class peer_filter_plugin final : public lt::peer_plugin
+{
+public:
+  peer_filter_plugin(lt::peer_connection_handle p, filter_function filter, action_function action)
+    : m_peer_connection(p)
+    , m_filter(std::move(filter))
+    , m_action(std::move(action))
+  {}
+
+  bool on_handshake(lt::span<char const> d) override
+  {
+    handle_peer(true);
+    return peer_plugin::on_handshake(d);
+  }
+
+  bool on_extension_handshake(lt::bdecode_node const& d) override
+  {
+    handle_peer(true);
+    return peer_plugin::on_extension_handshake(d);
+  }
+
+  bool on_interested() override
+  {
+    handle_peer();
+    return peer_plugin::on_interested();
+  }
+
+  bool on_not_interested() override
+  {
+    handle_peer();
+    return peer_plugin::on_not_interested();
+  }
+
+  bool on_have(lt::piece_index_t p) override
+  {
+    handle_peer();
+    return peer_plugin::on_have(p);
+  }
+
+  bool on_dont_have(lt::piece_index_t p) override
+  {
+    handle_peer();
+    return peer_plugin::on_dont_have(p);
+  }
+
+  bool on_bitfield(lt::bitfield const& bitfield) override
+  {
+    handle_peer();
+    return peer_plugin::on_bitfield(bitfield);
+  }
+
+  bool on_have_all() override
+  {
+    handle_peer();
+    return peer_plugin::on_have_all();
+  }
+
+  bool on_have_none() override
+  {
+    handle_peer();
+    return peer_plugin::on_have_none();
+  }
+
+  bool on_request(lt::peer_request const& r) override
+  {
+    handle_peer();
+    return peer_plugin::on_request(r);
+  }
+
+protected:
+  void handle_peer(bool handshake = false)
+  {
+    if (m_stop_filtering)
+      return;
+
+    lt::peer_info info;
+    m_peer_connection.get_peer_info(info);
+
+    if (m_filter(info, handshake, &m_stop_filtering))
+      m_action(m_peer_connection);
+  }
+
+private:
+  lt::peer_connection_handle m_peer_connection;
+
+  filter_function m_filter;
+  action_function m_action;
+
+  bool m_stop_filtering = false;
+};
+
+
+class peer_action_plugin : public lt::torrent_plugin
+{
+public:
+  peer_action_plugin(filter_function filter, action_function action)
+    : m_filter(std::move(filter))
+    , m_action(std::move(action))
+  {}
+
+  std::shared_ptr<lt::peer_plugin> new_connection(lt::peer_connection_handle const& p) override
+  {
+    return std::make_shared<peer_filter_plugin>(p, m_filter, m_action);
+  }
+
+private:
+  filter_function m_filter;
+  action_function m_action;
+};
diff --git a/src/base/bittorrent/peer_filter_session_plugin.hpp b/src/base/bittorrent/peer_filter_session_plugin.hpp
new file mode 100644
index 000000000..ce2ced76d
--- /dev/null
+++ b/src/base/bittorrent/peer_filter_session_plugin.hpp
@@ -0,0 +1,99 @@
+#pragma once
+
+#include <QDir>
+
+#include "base/logger.h"
+#include "base/profile.h"
+#include "base/path.h"
+
+#include "peer_filter_plugin.hpp"
+#include "peer_filter.hpp"
+#include "peer_logger.hpp"
+
+// filter factory function
+std::unique_ptr<peer_filter> create_peer_filter(const QString& filename)
+{
+  Path qbt_data_dir = specialFolderLocation(SpecialFolder::Data) / Path(filename);
+
+  QString filter_file = qbt_data_dir.toString();
+  // do not create plugin if filter file doesn't exists
+  if (!QFile::exists(filter_file)) {
+    LogMsg(u"'%1' doesn't exist. The corresponding filter is disabled."_s.arg(filename), Log::NORMAL);
+
+    return nullptr;
+  }
+
+  auto filter = std::make_unique<peer_filter>(filter_file);
+  if (filter->is_empty()) {
+    LogMsg(u"'%1' has no valid rules. The corresponding filter is disabled."_s.arg(filename), Log::WARNING);
+    filter.reset();
+  } else {
+    LogMsg(u"'%1' contains %2 valid rules."_s.arg(filename).arg(filter->rules_count()), Log::INFO);
+  }
+
+  return filter;
+}
+
+
+// drop connection action
+void drop_peer_connection(lt::peer_connection_handle ph)
+{
+  ph.disconnect(boost::asio::error::connection_refused, lt::operation_t::bittorrent, lt::disconnect_severity_t{0});
+}
+
+
+class peer_filter_session_plugin final : public lt::plugin
+{
+public:
+  peer_filter_session_plugin()
+    : m_blacklist(create_peer_filter(QStringLiteral("peer_blacklist.txt")))
+    , m_whitelist(create_peer_filter(QStringLiteral("peer_whitelist.txt")))
+  {
+  }
+
+  std::shared_ptr<lt::torrent_plugin> new_torrent(const lt::torrent_handle& th, client_data) override
+  {
+    // do not waste CPU and memory for useless objects when no filters are enabled
+    if (!m_blacklist && !m_whitelist)
+      return nullptr;
+
+    // ignore private torrents
+    if (th.torrent_file() && th.torrent_file()->priv())
+      return nullptr;
+
+    return std::make_shared<peer_action_plugin>([this](auto&&... args) { return filter(args...); }, drop_peer_connection);
+  }
+
+protected:
+  bool filter(const lt::peer_info& info, bool handshake, bool* stop_filtering) const
+  {
+    if (m_blacklist) {
+      // always match with both pid & client name when applying blacklist
+      bool matched_blacklist = m_blacklist->match_peer(info, false);
+      if (matched_blacklist) {
+        peer_logger_singleton::instance().log_peer(info, "blacklist");
+        *stop_filtering = true;
+        return true;
+      }
+    }
+
+    if (m_whitelist) {
+      bool matched_whitelist = m_whitelist->match_peer(info, handshake);
+      if (!matched_whitelist) {
+        peer_logger_singleton::instance().log_peer(info, "whitelist");
+        *stop_filtering = true;
+        return true;
+      }
+    }
+
+    // if the peer got passed the handshake phase and get here, don't filter it anymore
+    if (!handshake) {
+      *stop_filtering = true;
+    }
+    return false;
+  }
+
+private:
+  std::unique_ptr<peer_filter> m_blacklist;
+  std::unique_ptr<peer_filter> m_whitelist;
+};
diff --git a/src/base/bittorrent/peer_logger.hpp b/src/base/bittorrent/peer_logger.hpp
new file mode 100644
index 000000000..e2503bd9d
--- /dev/null
+++ b/src/base/bittorrent/peer_logger.hpp
@@ -0,0 +1,103 @@
+#pragma once
+
+#include <libtorrent/peer_info.hpp>
+
+#include <QSqlDatabase>
+#include <QSqlQuery>
+
+#include <QVariant>
+
+
+class db_connection
+{
+public:
+  static db_connection& instance()
+  {
+    static db_connection c;
+    return c;
+  }
+
+  void init(const QString& db_path)
+  {
+    m_db.setDatabaseName(db_path);
+    m_db.open();
+  }
+
+  QSqlDatabase connection() const
+  {
+    return m_db;
+  }
+
+protected:
+  db_connection()
+    : m_db(QSqlDatabase::addDatabase(u"QSQLITE"_s))
+  {}
+
+  ~db_connection()
+  {
+    m_db.close();
+  }
+
+private:
+  QSqlDatabase m_db;
+};
+
+
+class peer_logger
+{
+public:
+  explicit peer_logger(QSqlDatabase db, QString table)
+    : m_db(db)
+    , m_table(table)
+  {
+    if (!db.tables().contains(table)) {
+      db.exec(u"CREATE TABLE '%1' ("
+              u"    'id'      INTEGER PRIMARY KEY,"
+              u"    'ip'      TEXT NOT NULL UNIQUE,"
+              u"    'client'  TEXT NOT NULL,"
+              u"    'pid'     BLOB NOT NULL,"
+              u"    'tag'     TEXT"
+              u");"_s.arg(table));
+      db.commit();
+    }
+  }
+
+  bool log_peer(const lt::peer_info& info, const std::string& tag = {})
+  {
+    QSqlQuery q(m_db);
+    q.prepare(u"INSERT INTO '%1' (ip, client, pid, tag) VALUES (?, ?, ?, ?)"_s.arg(m_table));
+    q.addBindValue(QString::fromStdString(info.ip.address().to_string()));
+    q.addBindValue(QString::fromStdString(info.client));
+    q.addBindValue(QString::fromLatin1(info.pid.data(), 8));
+    q.addBindValue(QString::fromStdString(tag));
+    return q.exec();
+  }
+
+private:
+  QSqlDatabase m_db;
+  QString m_table;
+};
+
+
+class peer_logger_singleton
+{
+public:
+  static peer_logger_singleton& instance()
+  {
+    static peer_logger_singleton logger;
+    return logger;
+  }
+
+  void log_peer(const lt::peer_info& info, const std::string& tag)
+  {
+    m_logger.log_peer(info, tag);
+  }
+
+protected:
+  peer_logger_singleton()
+    : m_logger(db_connection::instance().connection(), QStringLiteral("banned_peers"))
+  {}
+
+private:
+  peer_logger m_logger;
+};
diff --git a/src/base/bittorrent/sessionimpl.cpp b/src/base/bittorrent/sessionimpl.cpp
index 496308fef..ce56745dc 100644
--- a/src/base/bittorrent/sessionimpl.cpp
+++ b/src/base/bittorrent/sessionimpl.cpp
@@ -98,6 +98,11 @@
 #include "loadtorrentparams.h"
 #include "lttypecast.h"
 #include "nativesessionextension.h"
+
+// patch: ban
+#include "peer_blacklist.hpp"
+// #include "peer_filter_session_plugin.hpp"
+
 #include "portforwarderimpl.h"
 #include "resumedatastorage.h"
 #include "torrentcontentremover.h"
@@ -1685,6 +1690,17 @@ void SessionImpl::initializeNativeSession()
     {
         QMetaObject::invokeMethod(this, &SessionImpl::readAlerts, Qt::QueuedConnection);
     });
+    
+    // patch: ban
+    const Path peersDbPath = specialFolderLocation(SpecialFolder::Data) / Path(u"peers.db"_s);
+    db_connection::instance().init(peersDbPath.toString());
+    
+    m_nativeSession->add_extension(&create_drop_bad_peers_plugin);
+    // m_nativeSession->add_extension(&create_drop_unknown_peers_plugin);
+    // m_nativeSession->add_extension(&create_drop_offline_downloader_plugin);
+    // m_nativeSession->add_extension(&create_drop_bittorrent_media_player_plugin);
+    // m_nativeSession->add_extension(std::make_shared<peer_filter_session_plugin>());
+    // m_nativeSession->add_extension(&create_peer_shadowban_plugin);
 
     // Enabling plugins
     m_nativeSession->add_extension(&lt::create_smart_ban_plugin);
diff --git a/src/base/version.h.in b/src/base/version.h.in
index b283be786..9917bf147 100644
--- a/src/base/version.h.in
+++ b/src/base/version.h.in
@@ -32,7 +32,7 @@
 #define QBT_VERSION_MINOR 1
 #define QBT_VERSION_BUGFIX 0
 #define QBT_VERSION_BUILD 0
-#define QBT_VERSION_STATUS "alpha1"  // Should be empty for stable releases!
+#define QBT_VERSION_STATUS ""  // Should be empty for stable releases!
 
 #define QBT__STRINGIFY(x) #x
 #define QBT_STRINGIFY(x) QBT__STRINGIFY(x)
diff --git a/src/gui/mainwindow.cpp b/src/gui/mainwindow.cpp
index 4798a6800..3fac080b6 100644
--- a/src/gui/mainwindow.cpp
+++ b/src/gui/mainwindow.cpp
@@ -530,13 +530,9 @@ void MainWindow::setDownloadTrackerFavicon(const bool value)
     m_storeDownloadTrackerFavicon = value;
 }
 
-void MainWindow::setTitleSuffix(const QString &suffix)
-{
-    const auto emDash = QChar(0x2014);
-    const QString separator = u' ' + emDash + u' ';
-    m_windowTitle = QStringLiteral("qBittorrent " QBT_VERSION)
-        + (!suffix.isEmpty() ? (separator + suffix) : QString());
-
+// patch: 设置窗口标题为 qbit
+void MainWindow::setTitleSuffix (const QString &suffix) {
+    MainWindow::m_windowTitle = QStringLiteral("qbit");
     refreshWindowTitle();
 }
 
diff --git a/src/gui/mainwindow.ui b/src/gui/mainwindow.ui
index 24c6ada61..b957b7d80 100644
--- a/src/gui/mainwindow.ui
+++ b/src/gui/mainwindow.ui
@@ -189,27 +189,27 @@
   </action>
   <action name="actionStart">
    <property name="text">
-    <string>Sta&amp;rt</string>
+    <string>开始</string>
    </property>
   </action>
   <action name="actionStop">
    <property name="text">
-    <string>Sto&amp;p</string>
+    <string>停止</string>
    </property>
   </action>
   <action name="actionResumeSession">
    <property name="text">
-    <string>R&amp;esume Session</string>
+    <string>继续</string>
    </property>
   </action>
   <action name="actionPauseSession">
    <property name="text">
-    <string>Pau&amp;se Session</string>
+    <string>暂停</string>
    </property>
   </action>
   <action name="actionDelete">
    <property name="text">
-    <string>&amp;Remove</string>
+    <string>删除</string>
    </property>
   </action>
   <action name="actionDownloadFromURL">
diff --git a/src/lang/qbittorrent_zh_CN.ts b/src/lang/qbittorrent_zh_CN.ts
index 4ceffe415..37b6a264d 100644
--- a/src/lang/qbittorrent_zh_CN.ts
+++ b/src/lang/qbittorrent_zh_CN.ts
@@ -2979,8 +2979,8 @@ Supports the formats: S01E01, 1x1, 2017.12.31 and 31.12.2017 (Date formats also
     </message>
     <message>
         <location filename="../gui/deletionconfirmationdialog.ui" line="91"/>
-        <source>Also permanently delete the files</source>
-        <translation>并永久删除这些文件</translation>
+        <source>Also remove the content files</source>
+        <translation>同时删除已下载的文件</translation>
     </message>
     <message>
         <location filename="../gui/deletionconfirmationdialog.cpp" line="45"/>
@@ -9631,10 +9631,15 @@ Click the &quot;Search plugins...&quot; button at the bottom right of the window
         <source>Completed (%1)</source>
         <translation>完成 (%1)</translation>
     </message>
+    <message>
+        <location filename="../gui/transferlistfilters/statusfilterwidget.cpp" line="170"/>
+        <source>Running (%1)</source>
+        <translation>运行 (%1)</translation>
+    </message>
     <message>
         <location filename="../gui/transferlistfilters/statusfilterwidget.cpp" line="171"/>
-        <source>Paused (%1)</source>
-        <translation>暂停 (%1)</translation>
+        <source>Stopped (%1)</source>
+        <translation>停止 (%1)</translation>
     </message>
     <message>
         <location filename="../gui/transferlistfilters/statusfilterwidget.cpp" line="178"/>
diff --git a/src/webui/www/private/css/Layout.css b/src/webui/www/private/css/Layout.css
index bdb540c0c..9dbdb60d7 100644
--- a/src/webui/www/private/css/Layout.css
+++ b/src/webui/www/private/css/Layout.css
@@ -357,7 +357,6 @@ div.toolbox.divider {
 
 .iconWrapper:hover {
     border: 1px solid #a0a0a0;
-    border-radius: 3px;
 }
 
 #spinnerWrapper {
diff --git a/src/webui/www/private/css/Tabs.css b/src/webui/www/private/css/Tabs.css
index 06a5cebb8..caa0641a5 100644
--- a/src/webui/www/private/css/Tabs.css
+++ b/src/webui/www/private/css/Tabs.css
@@ -41,7 +41,6 @@ Required by:
 .tab-menu li a {
     align-items: center;
     background-color: var(--color-background-default);
-    border-radius: 3px 3px 0 0;
     color: var(--color-text-default);
     display: flex;
     gap: 5px;
diff --git a/src/webui/www/private/css/Window.css b/src/webui/www/private/css/Window.css
index 2546a9dcb..2fa7fea0a 100644
--- a/src/webui/www/private/css/Window.css
+++ b/src/webui/www/private/css/Window.css
@@ -26,7 +26,6 @@ Required by:
 
 .mochaOverlay {
     background-color: var(--color-background-default);
-    border-radius: 5px;
     height: auto !important; /* also fixes out of block issue */
     left: 0;
     position: absolute; /* This is also set in theme.js in order to make theme transitions smoother */
@@ -46,7 +45,6 @@ Required by:
 
 .mochaTitlebar {
     background-color: var(--color-background-default);
-    border-radius: 5px;
     overflow: hidden;
     width: 100%;
 }
diff --git a/src/webui/www/private/css/style.css b/src/webui/www/private/css/style.css
index b99be2d02..6eb68a4c0 100644
--- a/src/webui/www/private/css/style.css
+++ b/src/webui/www/private/css/style.css
@@ -92,7 +92,6 @@ input[type="button"],
 button,
 select {
     border: 1px solid var(--color-border-default);
-    border-radius: 3px;
     color: var(--color-text-default);
     padding: 3px;
 }
@@ -205,7 +204,6 @@ dd {
 
 fieldset {
     border: 1px solid var(--color-border-default);
-    border-radius: 1px;
     margin: 0 2px;
 }
 
@@ -471,7 +469,6 @@ a.propButton img {
     background-repeat: no-repeat;
     background-size: 1.5em;
     border: 1px solid var(--color-border-default);
-    border-radius: 3px;
     min-width: 160px;
     padding: 2px 12px 2px 25px;
 }
@@ -486,7 +483,6 @@ a.propButton img {
     background-repeat: no-repeat;
     background-size: 1.5em;
     border: 1px solid var(--color-border-default);
-    border-radius: 4px;
     display: inline-block;
     height: 26px;
     margin-bottom: -9px;
@@ -500,7 +496,6 @@ a.propButton img {
     background-repeat: no-repeat;
     background-size: 1.5em;
     border: 1px solid var(--color-accent-blue);
-    border-radius: 4px;
     display: inline-block;
     height: 26px;
     margin-bottom: -9px;
diff --git a/src/webui/www/private/css/vanillaSelectBox.css b/src/webui/www/private/css/vanillaSelectBox.css
index 8191e5f17..17ac0171e 100644
--- a/src/webui/www/private/css/vanillaSelectBox.css
+++ b/src/webui/www/private/css/vanillaSelectBox.css
@@ -31,7 +31,6 @@ li[data-parent].open:not(.hidden-search) {
 }
 
 .vsb-js-search-zone input {
-    border-radius: 4px;
     height: 25px !important;
     margin-left: 2px;
     width: 96%;
@@ -73,7 +72,6 @@ li.short {
 
 .vsb-main button {
     border: 1px solid var(--color-border-default);
-    border-radius: 4px;
     min-width: 120px;
     padding: 6px 12px;
     text-align: left;
@@ -112,7 +110,6 @@ li.short {
 }
 
 .vsb-menu li.grouped-option.open span {
-    border-radius: 2px;
     display: inline-block;
     font-size: inherit;
     height: 8px;
@@ -122,7 +119,6 @@ li.short {
 }
 
 .vsb-menu li.grouped-option.closed span {
-    border-radius: 2px;
     display: inline-block;
     font-size: inherit;
     height: 8px;
@@ -132,7 +128,6 @@ li.short {
 
 .vsb-menu li.grouped-option i {
     border: 1px solid;
-    border-radius: 3px;
     display: inline-block;
     float: left;
     font-size: inherit;
@@ -162,7 +157,6 @@ li.short {
 
 .vsb-menu :not(.multi) li.active::before {
     border-bottom: 3px solid var(--color-border-blue);
-    border-radius: 2px;
     border-right: 3px solid var(--color-border-blue);
     content: "";
     display: inline-block;
@@ -186,7 +180,6 @@ li.short {
 .vsb-menu .multi li:not(.grouped-option)::before {
     background: var(--color-background-popup);
     border: 1px solid;
-    border-radius: 3px;
     content: "";
     display: inline-block;
     float: left;
diff --git a/src/webui/www/private/upload.html b/src/webui/www/private/upload.html
index 87f03871d..66d6349fa 100644
--- a/src/webui/www/private/upload.html
+++ b/src/webui/www/private/upload.html
@@ -14,7 +14,7 @@
 <body>
     <iframe id="upload_frame" name="upload_frame" class="invisible" title="" src="about:blank"></iframe>
     <form action="api/v2/torrents/add" enctype="multipart/form-data" method="post" id="uploadForm" style="text-align: center;" target="upload_frame" autocorrect="off" autocapitalize="none">
-        <div style="margin-top: 25px; display: inline-block; border: 1px solid lightgrey; border-radius: 4px;">
+        <div style="margin-top: 25px; display: inline-block; border: 1px solid lightgrey;">
             <input type="file" id="fileselect" accept=".torrent, application/x-bittorrent" name="fileselect[]" multiple aria-label="QBT_TR(Select .torrent files)QBT_TR[CONTEXT=AddNewTorrentDialog]">
         </div>
         <fieldset class="settings" style="border: 0; text-align: left; margin-top: 12px;">
diff --git a/src/webui/www/private/views/log.html b/src/webui/www/private/views/log.html
index 71282c1a7..50c01eff6 100644
--- a/src/webui/www/private/views/log.html
+++ b/src/webui/www/private/views/log.html
@@ -45,7 +45,6 @@
         margin-left: .3em;
         width: 237px;
         border: 1px solid var(--color-border-default);
-        border-radius: 3px;
     }
 
     #logFilterSummary {
diff --git a/src/webui/www/private/views/rssDownloader.html b/src/webui/www/private/views/rssDownloader.html
index d07f7d20c..e29fe001f 100644
--- a/src/webui/www/private/views/rssDownloader.html
+++ b/src/webui/www/private/views/rssDownloader.html
@@ -99,7 +99,6 @@
         width: 24px;
         margin: 1px 2px 1px 2px;
         border: 1px solid;
-        border-radius: 2px;
         background-color: #efefef;
         border-color: #767676;
         background-position: center center;
diff --git a/src/webui/www/private/views/search.html b/src/webui/www/private/views/search.html
index 6b609fdf0..af911a887 100644
--- a/src/webui/www/private/views/search.html
+++ b/src/webui/www/private/views/search.html
@@ -6,7 +6,6 @@
         background-size: 1.5em;
         background-position: left;
         border: 1px solid var(--color-border-default);
-        border-radius: 3px;
         padding: 0 0 0 25px;
     }
 
diff --git a/vcpkg-configuration.json b/vcpkg-configuration.json
new file mode 100644
index 000000000..d1e49a276
--- /dev/null
+++ b/vcpkg-configuration.json
@@ -0,0 +1,14 @@
+{
+  "default-registry": {
+    "kind": "git",
+    "baseline": "22038fe87d695e769a98e1561031194383ec8ded",
+    "repository": "https://github.com/microsoft/vcpkg"
+  },
+  "registries": [
+    {
+      "kind": "artifact",
+      "location": "https://github.com/microsoft/vcpkg-ce-catalog/archive/refs/heads/main.zip",
+      "name": "microsoft"
+    }
+  ]
+}
diff --git a/vcpkg.json b/vcpkg.json
new file mode 100644
index 000000000..18cee1111
--- /dev/null
+++ b/vcpkg.json
@@ -0,0 +1,12 @@
+{
+  "dependencies": [
+    "boost-circular-buffer",
+    "boost-stacktrace",
+    "zlib",
+    "openssl",
+    "libtorrent",
+    "qtbase",
+    "qttools",
+    "qtsvg"
+  ]
+}
